# -*- coding: utf-8 -*-

#3a) Un formato per specificare la struttura secondaria di una molecola di RNA 
# (senza pseudonodi), noto come "dot-bracket notation", prevede che si 
# utilizzi una stringa sull'alfabeto '.()' in cui, se nella posizione di 
# indice i si ha '.', la relativa base non è appaiata, se si ha '(', la base 
# con cui è appaiata si trova a valle, a un indice j>i, invece se si ha ')', 
# la base con cui è appaiata ha un indice j<i.
# Nel formato detto "CT" la struttura secondaria è rappresentata da una lista 
# di interi, ciascuno dei quali corrisponde alla base con cui la base in tale 
# posizione risulta appaiata, o la posizione stessa se non c'è appaiamento.
# Si scriva una funzione db2ct(s) che, data una stringa s che rappresenta una 
# struttura in formato "dot-bracket", restituisca la stessa in formato "CT" 
# come lista di interi.
# Nota 1: il formato ufficiale ".ct" ha una sintassi più complessa di quella 
# qui indicata.
# Nota 2: una pila (politica di accesso LIFO) può essere implementata con una 
# lista Python, unitamente all'uso dei metodi "append" e "pop".
#
# Es: x = '..((..).)'
#     db2ct(x)   #-> [0, 1, 8, 6, 4, 5, 3, 7, 2]


def db2ct(s):   
    mystack = list()
    res = list()
    try:
        for i, c in enumerate(s):
            if c =='.':
                res.append(i)
            elif c == '(':
                mystack.append(i)
                res.append(None)
            elif c == ')':
                other = mystack.pop()
                res[other] = i
                res.append(other)
            else: #no other char is allowed
                raise ValueError
    except: #pop failed: exceeding closing brackets
        raise ValueError
    if mystack: # not enough closing brackets
        raise ValueError
    
    return res

