# -*- coding: utf-8 -*-

#4a) Dato un insieme di stringhe della stessa lunghezza, la loro "stringa 
# consenso" è quella che in ogni posizione ha il carattere che più spesso 
# compare in quella posizione tra tutte le stringhe dell'insieme. Talvolta può 
# accadere che, in una posizione, più di un carattere compaia con la frequenza 
# massima. Si può costruire una "lista consenso" i cui elementi siano: i) un 
# carattere, nel caso in cui in tale posizione ci sia solo tale carattere con 
# frequenza massima, oppure ii) una lista (ordinata) di tutti i caratteri con 
# frequenza massima su tale posizione.
# Si scriva una funzione consensuslist(strs) che, data una lista di stringhe 
# strs tutte di uguale lunghezza, restituisca la relativa lista consenso.  
#
# Es: s = ["banana","camini","flotta","befane"]
#     consensuslist(s)  # --> ['b', 'a', ['f', 'm', 'n', 'o'], 'a', 'n', 'a']


def consensuslist(strs):
    """
    Returns the consensus list for the list of strings given as input
    (all should be of the same length: this condition is not checked).
    """

    def getmostfrequent(s):    #inner help function
        d = {k:s.count(k) for k in set(s)}
        mmax = max(d.values())
        return sorted(k for k in d if d[k]==mmax)
    
    res = []
    for tup in zip(*strs):
        outcome = getmostfrequent(tup)
        res.append(outcome if len(outcome)>1 else outcome[0])
    return res

